c****interface to access parton distribution functions and QCD couplings from LHAPDF****

      Subroutine SetPdf(pdfname, mem)
      implicit none
      integer mem, first
      character*40 pdfname
      common /pdfcontrol/ first

      first=0
      Call SetLHAPARM('SILENT') 
      call InitPDFSetbyname(pdfname)
      call InitPDF(mem)

      end subroutine 


      DOUBLE PRECISION FUNCTION ALPHAS(Q)
      implicit none
      DOUBLE PRECISION Q, alphasPDF, tmp

      alphas = alphasPDF(Q)

      RETURN

      END FUNCTION


      double precision function PARTON(ppp,xxx,scales)
      implicit none
      double precision xxx,scales,xx(3),ss(3),d(3)
      double precision pdfs(-6:6, 3), eval(-6:6)
      integer i, j, k, ppp, first
      common /pdfcontrol/ first
      common /pdfmem/ xx, ss, pdfs

      if(first.eq.0) then
      do i=1, 3
      xx(i)=0.d0
      ss(i)=0.d0
      do j=-6, 6
      pdfs(j, i)=0.d0
      enddo
      enddo
      first=1
      endif
   
      if((xxx.lt.0.d0).or.(xxx.gt.1.d0)) then
              print *, "warning: PDF x out of range", xxx
              PARTON=0.d0
              return
      endif

      do i=1, 3
      d(i)=abs(xxx-xx(i))+abs(scales-ss(i))
      if(d(i).eq.0.d0) then
      do j=-6, 6
      eval(j)=pdfs(j, i)
      enddo
      goto 100
      endif
      enddo

      call evolvePDF(xxx,scales,eval)
      do k=-6, 6
      eval(k)=eval(k)/xxx
      enddo

100   do i=1, 2
      do j=-6, 6
      pdfs(j, i)=pdfs(j, i+1)
      enddo
      xx(i)=xx(i+1)
      ss(i)=ss(i+1)
      enddo

      xx(3)=xxx
      ss(3)=scales
      do j=-6, 6
      pdfs(j, 3)=eval(j)
      enddo

      PARTON=eval(ppp)
      return

      end function

